using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Controllers.Master.AppUrl;
using WK_KLI_LAPS_Service.Models.Master;

// For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace WK_KLI_LAPS_Service.Controllers.Master.Customer
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class AppUrlApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private IAppUrlService _AppUrlService;
        public AppUrlApiController(IAppUrlService AppUrlService)
        {
            _AppUrlService = AppUrlService;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _AppUrlService.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveAppUrls")]
        //Code to retrieve active data
        public IActionResult GetActiveCustomer()
        {
            var _list = _AppUrlService.GetActiveAppUrl();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] appurlModel oappurlModel)
        {

            int retval = 0;
            try
            {
                retval = _AppUrlService.Add(oappurlModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] appurlModel oappurlModel)
        {
            int retval = 0;
            try
            {
                retval = _AppUrlService.Edit(oappurlModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] appurlModel ocustomerModel)
        {
            int retval = 0;
            try
            {
                retval = _AppUrlService.Delete(ocustomerModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}
